<template>
  <div>
    <v-container>
      <v-row>
        <v-col cols="3">
          <v-card height="100%" class="mt-3">
            <user-label :user="currentUser"></user-label>
            <menu-synchro-calendriers/>
          </v-card>
        </v-col>
        <v-col>
          <v-container>
            <v-row>
              <v-col>
                <presence-du-jour titre="Aujourd'hui"></presence-du-jour>
              </v-col>
              <v-col>
                <presence-du-jour titre="Demain" :date="demain"></presence-du-jour>
              </v-col>
            </v-row>
            <v-row cols="12">
              <v-col>
                <v-btn width="100%" v-on:click="vueALaSemaine(cetteSemaine)"> Voir la semaine en cours</v-btn>
              </v-col>
              <v-col>
                <v-btn width="100%" v-on:click="vueALaSemaine(semaineProchaine)"> Voir la semaine prochaine</v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-col>
      </v-row>
    </v-container>
    <v-dialog v-model="dialogNewUser">
      <v-card>
        <v-card-title>On ne se connait pas !</v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-switch v-model="aLaCle" :label="'As-tu la clé de l\'agence ?'"></v-switch>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-btn icon outlined v-on:click="enregistrerNouvelUtilisateur()">
            <v-icon>mdi-content-save</v-icon>
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>

</template>

<script>

import UserLabel from "@/components/UserLabel";
import PresenceDuJour from "@/components/PresenceDuJour";
import moment from "moment";
import presenceService from "@/services/presences-service"
import {mapActions, mapGetters} from "vuex";
import MenuSynchroCalendriers from "@/views/MenuSynchroCalendriers";

export default {
  name: 'Home',
  components: {MenuSynchroCalendriers, PresenceDuJour, UserLabel},
  data() {
    return {
      dialogNewUser: false,
      aLaCle: false
    }
  },
  computed: {
    ...mapGetters(['currentUser']),
    demain() {
      return moment().add(1, "day").format("YYYY-MM-DD")
    },
    cetteSemaine() {
      return String(moment().isoWeek()).padStart(2, '0')
    },
    semaineProchaine() {
      return String(moment().add(7, "days").isoWeek()).padStart(2, '0')
    }
  },
  mounted() {
    const currentGoogleUser = this.$gapi.getUserData()
    presenceService.getUser(currentGoogleUser.id).then(userBdd => {
      console.log(userBdd)
      if (!userBdd.id_google) {
        this.dialogNewUser = true
      } else {
        this.setCurrentUser(userBdd)
      }
    })
  },
  methods: {
    ...mapActions(["setCurrentUser"]),
    vueALaSemaine(numeroDeLaSemaine) {
      this.$router.push({path: '/week', query: {'semaine': numeroDeLaSemaine}})
    },
    enregistrerNouvelUtilisateur() {
      presenceService.addUser(this.$gapi.getUserData(), this.aLaCle).then(new_user => {
        console.log(new_user)
        this.setCurrentUser(new_user)
      })
      this.dialogNewUser = false
    }
  }
}
</script>
